/***************************************
 *        program name: v64jr.c        *
 *  N64 cart emulator transfer program *
 ***************************************/

/* Modified by nop- */
/* Compiled with msc V6.0 for DOS */

#include <conio.h>
#include <dos.h>
#include <graph.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
//#include <dir.h>

//#define ai 0x37b
//#define data 0x37c
#define trans_size 32768

#define inportb _inp
#define INPORT _inpw
#define outportb _outp
#define OUTPORT _outpw

#define set_ai_write outportb(port_a,5);		// ninit=1, nwrite=0
#define set_data_write outportb(port_a,1);	// ninit=0, nwrite=0
#define set_data_read outportb(port_a,0);	// ninit=0, nwrite=1
#define set_normal outportb(port_a,4);		// ninit=1, nwrite=1

char *file_name=NULL;
char write_en=0;
char test_en=0;
char verify_en=0;
char disp_on=1;
FILE *fptr;
union mix_buffer {
unsigned char buffer[32768];
unsigned int bufferx[16384];
}mix;
unsigned int port[2];
unsigned char port_no;
unsigned int port_8,port_9,port_a,port_b,port_c;
unsigned char disp_buf[16];
int i,j,page,sel,err,wv_mode;
char ch=' ';


//#include "printf.c"

/**************************************
*               Subroutine            *
**************************************/
void dump_buffer(void)
{
for (i=0; i<128 ; i++)
   {
   j=i & 0x0f;
   disp_buf[j]=mix.buffer[i];
   if (j==15)
      {
      printf("%04x : ",i&0xfff0);
      for (j=0; j<16 ; j++)
	 {
	 if (j==8) printf("- ");
	 printf("%02x ",disp_buf[j]);
	 }
      printf("-> ");
      for (j=0; j<16 ; j++)
	 {
	 if (disp_buf[j] < 0x20 || disp_buf[j] > 0x80)
	    printf (".");
	 else
	    printf ("%c",disp_buf[j]);
	 }
      printf("\n");
      }
   }
}

void set_ai(unsigned char _ai)
{
   set_ai_write			// ninit=1, nwrite=0
   outportb(port_b,_ai);
}

void set_ai_data(unsigned char _ai,unsigned char _data)
{
   set_ai(_ai);
   set_data_write		// ninit=0, nwrite=0
   outportb(port_c,_data);
}

void init_port(void)
{
   outportb(port_9,1);		// clear EPP time flag
   set_ai_data(6,0x0a);
   set_ai_data(7,0x05);		// 6==0x0a, 7==0x05 is pc_control mode
//   set_ai(5);
//   set_data_read
//   write_en=inportb(port_c);
   set_ai_data(5,write_en);		// d0=0 is write protect mode
}

void end_port(void)
{
   set_ai_data(5,write_en);		// d0=0 is write protect mode
   set_ai_data(7,0);		// release pc mode
   set_ai_data(6,0);		// 6==0x0a, 7==0x05 is pc_control mode
   set_normal			// ninit=1, nWrite=1
}

char write_32k(unsigned int hi_word, unsigned int lo_word)
{
   unsigned char unpass,pass1;
   unsigned int i,j;
   unsigned int fix,temp;
   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   for (i=0;i<0x40;i++){
      unpass=3;
      while(unpass){
	 set_ai_data(1,((i<<1)|lo_word));
	 set_ai_data(0,0);
	 set_ai(4);		// set address index=4
	 set_data_write		// ninit=0, nWrite=0
	 fix=i<<8;
	 for (j=0;j<256;j++){
            OUTPORT(port_c,mix.bufferx[j+fix]);
	 }
	 set_data_read		// ninit=0, nWrite=1
	 if (wv_mode){
	    for (j=0;j<256;j++){
               temp=INPORT(port_c);
	       if(mix.bufferx[j+fix]!=temp){
//		  printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
		  break;
	       }
	    }
	 }
	 else{
	    pass1=1;
	    for (j=0;j<4;j++){
               temp=INPORT(port_c);
	       if(mix.bufferx[j+fix]!=temp){
//		  printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
		  pass1=0;
		  break;
	       }
	    }
	    if (pass1) {
//	       printf("@");
	       set_ai_data(1,((i<<1)|lo_word|1));
	       set_ai_data(0,0xf8);
	       set_ai(4);
	       set_data_read		// ninit=0, nWrite=1
	       for (j=252;j<256;j++){
                  temp=INPORT(port_c);
		  if(mix.bufferx[j+fix]!=temp){
//		     printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
		     break;
		  }
	       }
	    }
	 }
	 set_ai(0);
	 set_data_read			// ninit=0, nwrite=1
	 if (inportb(port_c)!=0x00){
	    unpass--;
//	    printf("counter=%x ",inportb(data));
	    outportb(port_a,0x0b);	// set all pin=0 for debug
	    if (disp_on) printf("*");
	    init_port();
	    set_ai_data(3,0x10|(hi_word>>8));
	    set_ai_data(2,(hi_word & 0xff));
	    if (unpass==0)
	       return(1);
	 }
	 else
	    unpass=0;
      }
   }
//   outportb(ai,0);
//   printf("\na[7..0]=%02x\n",inportb(data));
//   outportb(ai,1);
//   printf("a[15..8]=%02x\n",inportb(data));
//   end_port();
   return(0);
}

void PrintHexByte (unsigned int b)
   {
   if ((b & 255) < 0x10)
      printf("0");
   printf("%x ",(b&255));
   }

void ClearMemArea (void)
   {
   unsigned int lo_word = 0xff00;
   unsigned int hi_word = 0x01ff;

   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   set_ai_data(1,(lo_word>>8));
   set_ai_data(0,(lo_word & 0xff));
   set_ai(4);
   set_data_write          // ninit=0, nwrite=1
   for (i=0; i<128; i++)
      {
      OUTPORT(port_c,0x0);
      }
   }

void ShowChar(void)
   {
   unsigned int lo_word = 0xfffe;
   unsigned int hi_word = 0x01ff;
   unsigned int temp,x,y;

   init_port();
   set_ai(3);
   set_data_read

   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   set_ai_data(1,(lo_word>>8));
   set_ai_data(0,(lo_word & 0xff));
   set_ai(4);
   set_data_read          // ninit=0, nwrite=1

   temp=INPORT(port_c);
   printf("[%x]",temp);

   if ((temp/256) == 1)
      {

//      printf("%c",(temp%256));

      init_port();
      set_ai_data(3,0x10|(hi_word>>8));
      set_ai_data(2,(hi_word & 0xff));
      set_ai_data(1,(lo_word>>8));
      set_ai_data(0,(lo_word & 0xff));
      set_ai(4);
      set_data_write          // ninit=0, nwrite=1
      OUTPORT(port_c,0x0);

      }
   end_port();
   }

void MemoryDump (void)
   {
   unsigned int lo_word = 0xff00;
   unsigned int hi_word = 0x01ff;
   unsigned int temp,x,y;
   unsigned int index = 0x0;
   unsigned int mem[128];
   struct _rccoord oldpos;
//   oldpos.row = 15;
//   oldpos.col = 0;

//   ShowChar();

//   init_port();
//   set_ai(3);
//   set_data_read

   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   set_ai_data(1,(lo_word>>8));
   set_ai_data(0,(lo_word & 0xff));
   set_ai(4);
   set_data_read          // ninit=0, nwrite=1
   for (i=0; i<128; i++)
      mem[i] = INPORT(port_c);
   end_port();

   _settextposition ( 3, 1);

   for (y=0; y<16; y++)
      {
      printf("b1ffff");
      if (index == 0) printf("0");
      printf("%x: ",index);

      index = index + 16;
      for (x=0; x<8; x++)
         {
         temp = mem[x+(y*8)];
         PrintHexByte(temp%256);
         PrintHexByte(temp/256);
//         printf(" ");
         }
      printf("\n");
      }

//    printf("%d,%d",oldpos.col, oldpos.row);

    oldpos = _gettextposition ();
//   _settextposition ( oldpos. oldpos.col );
   }

void MemoryDump2 (void)
   {
   unsigned int lo_word = 0x0000;
   unsigned int hi_word = 0x01ff;
   unsigned int temp,x,y;
   unsigned int index = 0x0;
   unsigned int mem[128];
   struct _rccoord oldpos;
//   oldpos.row = 15;
//   oldpos.col = 0;

//   ShowChar();

//   init_port();
//   set_ai(3);
//   set_data_read

   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   set_ai_data(1,(lo_word>>8));
   set_ai_data(0,(lo_word & 0xff));
   set_ai(4);
   set_data_read          // ninit=0, nwrite=1
   for (i=0; i<128; i++)
      mem[i] = INPORT(port_c);
   end_port();

   _settextposition ( 3, 1);

   for (y=0; y<16; y++)
      {
      printf("b1ff00");
      if (index == 0) printf("0");
      printf("%x: ",index);

      index = index + 16;
      for (x=0; x<8; x++)
         {
         temp = mem[x+(y*8)];
         PrintHexByte(temp%256);
         PrintHexByte(temp/256);
//         printf(" ");
         }
      printf("\n");
      }

//    printf("%d,%d",oldpos.col, oldpos.row);

//    oldpos = _gettextposition ();
//   _settextposition ( oldpos. oldpos.col );
   }

void PrintDump (void)
   {
   unsigned int lo_word = 0xfff4;
   unsigned int hi_word = 0x01ff;
   unsigned int lo_end, hi_end;

   unsigned int temp,x,y;
   unsigned int index = 0x0;
   unsigned int mem[128];
   struct _rccoord oldpos;

   // get wrap flag
   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   set_ai_data(1,(lo_word>>8));
   set_ai_data(0,(lo_word & 0xff));
   set_ai(4);
   set_data_read          // ninit=0, nwrite=1

   temp = INPORT(port_c);

   // Get end buffer pointer
   lo_word = 0xfff0;
   hi_word = 0x01ff;

   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   set_ai_data(1,(lo_word>>8));
   set_ai_data(0,(lo_word & 0xff));
   set_ai(4);
   set_data_read          // ninit=0, nwrite=1

   hi_end = INPORT(port_c) & 0x1ff;
   lo_end = INPORT(port_c) + 2;

   if (temp)
      {
      //Start address is same as buffer pointer
      hi_word = hi_end;
      lo_word = lo_end;

      }
    else
      {
      //Start address is start of buffer address
      hi_word = 0x01ff;
      lo_word = 0x0000 + 2;
      }

   printf("buffer start = %x %x\n", hi_word, lo_word);

   do
      {
      init_port();
      set_ai_data(3,0x10|(hi_word>>8));
      set_ai_data(2,(hi_word & 0xff));
      set_ai_data(1,(lo_word>>8));
      set_ai_data(0,(lo_word & 0xff));
      set_ai(4);
      set_data_read          // ninit=0, nwrite=1

      temp = INPORT(port_c);
      printf("%c", temp);

      lo_word +=4;
      if (lo_word < 4) hi_word++;

      // If we are past the end of buffer then wrap-around.
      if ( (hi_word == 0x01ff) &&
           (lo_word == 0xfff2) )
         {
         //Start address is start of buffer address
         hi_word = 0x01ff;
         lo_word = 0x0000 + 2;
         }
      }
   while ( (lo_word!=lo_end) ||
           (hi_word!=hi_end)  );

   end_port();

   }

void PrintDump2 (void)
   {
   unsigned int lo_word = 0x0000 + 2;
   unsigned int hi_word = 0x01ff;
   unsigned int lo_end, hi_end;

   unsigned int i,temp,x,y;
   unsigned int index = 0x0;
//   unsigned int mem[128];
//   struct _rccoord oldpos;


   for (i=0; i<16384; i++)
      {

      if ((i & 0x7f) == 0)
         {
         lo_word = (i*4) + 2;

         // set read address
         init_port();
         set_ai_data(3,0x10|(hi_word>>8));
         set_ai_data(2,(hi_word & 0xff));
         set_ai_data(1,(lo_word>>8));
         set_ai_data(0,(lo_word & 0xff));
         set_ai(4);
         set_data_read          // ninit=0, nwrite=1
         }
      temp = INPORT(port_c);
      mix.buffer[i] = (unsigned char)temp;
      (void) INPORT(port_c);

      // If at end of printf list then exit
      if (temp == 0)
         i = 16384;
      }

   end_port();

   i = 0;

   _settextposition ( 3, 1);

   while( mix.buffer[i] != '\0' )
      {

      if (mix.buffer [i] == 13)
         {
         printf("\n");
         i++;
         }
      else
         putchar( mix.buffer[i++] );


//      putchar( mix.buffer[i++] );
//      if (mix.buffer [i-1] == 13)
//         putchar(10);
      }
   }

char verify_32k(unsigned int hi_word, unsigned int lo_word)
{
   char unpass;
   unsigned int i,j,temp;
   unsigned int fix;
   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
//   set_ai_data(3,0x10);
//   set_ai_data(2,hi_word);
   for (i=0;i<0x40;i++){
      unpass=3;
      while(unpass){
	 set_ai_data(1,((i<<1)|lo_word));
	 set_ai_data(0,0);
	 set_ai(4);
	 set_data_read			// ninit=0, nwrite=1
	 fix=i<<8;
	 for (j=0;j<256;j++){
            temp=INPORT(port_c);
	    if (temp!=mix.bufferx[j+fix]){
//	       printf("verify error!!!\07\n");
//	       printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
	       outportb(port_a,0x0b);	// all pin=0 for debug
	       if (disp_on) printf("#");
	       init_port();
	       set_ai_data(3,0x10|(hi_word>>8));
	       set_ai_data(2,(hi_word & 0xff));
	       unpass--;
	       if (unpass==0)
		   return(1);
	       else
		  break;
	    }
	 }
	 if (j==256) break;
      }
   }
//   outportb(ai,0);
//   printf("\na[7..0]=%02x\n",inportb(data));
//   outportb(ai,1);
//   printf("a[15..8]=%02x\n",inportb(data));
//   end_port();
   return(0);
}

void read_adr(void)
{
   set_ai_data(6,0x0a);		// enable pc mode
   set_ai_data(7,0x05);		// enable pc mode
   printf("\na[31..0]=");
   set_ai(3);
   set_data_read		// ninit=0, nwrite=1
   printf("%02x",inportb(port_c));
   set_ai(2);
   set_data_read		// ninit=0, nwrite=1
   printf("%02x",inportb(port_c));
   set_ai(1);
   set_data_read		// ninit=0, nwrite=1
   printf("%02x",inportb(port_c));
   set_ai(0);
   set_data_read		// ninit=0, nwrite=1
   printf("%02x\n",inportb(port_c));
   end_port();
}

void read_some(void)
{
   init_port();
   set_ai_data(0,0);
   set_ai_data(1,0);
   set_ai_data(2,0);
   set_ai_data(3,0x10);
   set_ai(4);
   set_data_read		// ninit=0, nWrite=1
   for (i=0;i<64;i++) {
      mix.bufferx[i]=INPORT(port_c);
   }
   dump_buffer();
   read_adr();
}

unsigned char check_card(void)
{
   init_port();
   set_ai_data(3,0x12);
   set_ai_data(2,0x34);
   set_ai_data(1,0x56);
   set_ai_data(0,0x78);
   set_ai(3);
   set_data_read		// ninit=0, nwrite=1
   if ((inportb(port_c)&0x1f)!=0x12) return(1);
   set_ai(2);
   set_data_read		// ninit=0, nwrite=1
   if (inportb(port_c)!=0x34) return(1);
   set_ai(1);
   set_data_read		// ninit=0, nwrite=1
   if (inportb(port_c)!=0x56) return(1);
   set_ai(0);
   set_data_read		// ninit=0, nwrite=1
   if (inportb(port_c)!=0x78) return(1);
   end_port();
   return(0);
}

int read_file(void)
{
   if (fread((char *)mix.buffer,sizeof(char),trans_size,fptr)!=trans_size)
      {
      fclose(fptr);	/* read data error */
      return(-1);
      }
   printf(".");
   return(0);
}

int download_n64()
{
   if((fptr=fopen(file_name,"rb"))==NULL)
      {/* open error */
      printf("open error !!!\07\n");
      return(-1);
      }
   if (sel==0)
      printf("Downloading");
   else
      printf("Verifying");
   for (page=0;page<0x200;page++) {
      if (read_file()!=0){
	 fclose(fptr);
	 printf("\n");
	 return (0);
      }

      if (sel==0){
	 if (write_32k(page,0)) {
	    read_adr();
	    fclose(fptr);
	    return(-1);
	 }
      }
      else{
	 if(verify_32k(page,0)) {
	    read_adr();
	    fclose(fptr);
	    return(-1);
	 }
      }
      if (read_file()!=0){
	 fclose(fptr);
	 return (-1);
      }
      if (sel==0){
	 if (write_32k(page,0x80)) {
	    read_adr();
	    fclose(fptr);
	    return(-1);
	 }
      }
      else{
	 if(verify_32k(page,0x80)) {
	    read_adr();
	    fclose(fptr);
	    return(-1);
	 }
      }

      }
   printf("\n");
   fclose(fptr);
   end_port();
   return(0);
}

void gen_pat_32k(unsigned int offset)
{
   for (i=0; i<0x4000; i++){
      mix.bufferx[i]=i+offset;
   }
}


unsigned int test_dram(void)
{
   unsigned int pages;
   disp_on=0;		// display off
   sel=0;		//write 32k dram data
   gen_pat_32k(0x0000);
   write_32k(0,0);
   gen_pat_32k(0x8000);
   write_32k(0x100,0);
   gen_pat_32k(0x0000);
   pages=0;
   if (verify_32k(0,0)==0){	// find lower 128Mbits
      pages=0x100;
   }
   gen_pat_32k(0x8000);
   if (verify_32k(0x100,0)==0){	// find upper 128Mbits
      pages=0x200;
   }
   printf("DRAM testing...");
   for (page=0; page<pages; page++){
       gen_pat_32k(page*2);
       if (write_32k(page,0))
	  return(0);
       else
	  printf("w");
       gen_pat_32k(page*2 +1);
       if (write_32k(page,0x80))
	  return(0);
       else
	  printf("w");
   }
   for (page=0; page<pages; page++){
       gen_pat_32k(page*2);
       if (verify_32k(page,0))
	  return(0);
       else
	  printf("v");
       gen_pat_32k(page*2 +1);
       if (verify_32k(page,0x80))
	  return(0);
       else
	  printf("v");
   }
   return(pages);
}

void MemoryDumpLoop (void)
   {

//      ClearMemArea ();
      end_port ();

      printf("Turn on or press Reset on N64. Press any key when ready.");
      while (!_kbhit())
         {}
      (void) _getch();   //Ignore keypress

      _clearscreen( _GCLEARSCREEN );
      _displaycursor (_GCURSOROFF );

      printf("\nMemory dump mode:\n");
      while (!_kbhit() )
         {
         int i;
//         ShowChar();
         MemoryDump ();
         for (i=0; i<32767; i++)
           {};
         }

     _settextposition ( 19, 1);

      _displaycursor (_GCURSORON );

   }

void MemoryDumpLoop2 (void)
   {

//      ClearMemArea ();
      end_port ();

      printf("Turn on or press Reset on N64. Press any key when ready.");
      while (!_kbhit())
         {}
      (void) _getch();   //Ignore keypress

      _clearscreen( _GCLEARSCREEN );
      _displaycursor (_GCURSOROFF );

      printf("\nMemory dump mode:\n");
      while (!_kbhit() )
         {
         int i;
//         ShowChar();
         MemoryDump2 ();
         for (i=0; i<32767; i++)
           {};
         }

     _settextposition ( 19, 1);

      _displaycursor (_GCURSORON );

   }

void PrintDumpLoop (void)
   {

//      ClearMemArea ();
      end_port ();

      printf("Turn on or press Reset on N64. Press any key when ready.");
      while (!_kbhit())
         {}
      (void) _getch();   //Ignore keypress

      _clearscreen( _GCLEARSCREEN );
      _displaycursor (_GCURSOROFF );

      printf("\nPrintf dump mode:\n");
      while (!_kbhit() )
         {
         int i;

         PrintDump2 ();

         // delay
         for (i=0; i<32767; i++)
           {
           i = i + 2;
           i = i - 2;
           };
         }

//     _settextposition ( 19, 1);

      _clearscreen( _GCLEARSCREEN );
      _displaycursor (_GCURSORON );

   }

void usage(char *progname)
{
   fprintf(stderr, "Usage: %s [-m] [-w] [-v] [-t] [-a] <File>\n", progname);
   fprintf(stderr, "-w : DRAM write protect disabled.\n");
   fprintf(stderr, "-v : verify File data vs DRAM data.\n");
   fprintf(stderr, "-t : test DRAM.\n");
   fprintf(stderr, "-a : enable cartridge and unprotect.\n");
   fprintf(stderr, "-d : real time printf display\n");
   fprintf(stderr, "-p : display printf buffer ( Use: 'drjr -p > file' to write to file)\n");
   end_port();
   exit(2);
}


/*************************************************
*                  MAIN ENTRY                    *
*************************************************/
int main(int argc, char *argv[])
{
   char MemDump = 0;
   char MemDump2 = 0;
   char PntDump = 0;
   char PntDump2 = 0;

   char card_present;
   char *progname=argv[0];
   unsigned int dram_size;

   int a = 31;

   printf("---------- DrJr pc-download EPP version 1.0.1 by nop_ ----------\n");

//   jprintf("Test = %x\n",a);

   port[0]=0x378; //peek(0x40,8);                // lpt1 base address
   port[1]=0; //peek(0x40,10);               // lpt2 base address
   if (port[0]==0){
      printf("No Printer Port Available!\07\n");
      return(-1);
   }

   if (port[1]==0)
      port_no=1;		// only one printer port
   else
      port_no=2;		// two printer port
   card_present=0;

   for (i=0;i<port_no;i++){
      port_8=port[i];
      port_9=port_8+1;
      port_a=port_9+1;
      port_b=port_a+1;
      port_c=port_b+1;
      if (check_card()==0){
	 card_present=1;
	 break;
      }
   }

//   dump();

    if (argc==1) usage(progname);
    for( i=1; i<argc; i++ ) {
       if( argv[i][0] == '-' ) {
	  char *c = argv[i]+1;
	  if( *(c+1) != '\0' ) usage(progname);
	  switch( *c ) {
//         case 'b':
//        MemDump2 = 1;
//        write_en = 1;
//        break;
         case 'd':
        PntDump2 = 1;
        write_en = 1;
        break;
//         case 'm':
//        MemDump = 1;
//        write_en = 1;
//        break;
         case 'p':
        PntDump = 1;
        write_en = 1;
        break;
         case 'w':          //write protect disable
		write_en = 1;
		break;
         case 'v':          //verify DRAM vs file
		verify_en = 1;
		break;
         case 't':          //test dram
		test_en = 1;
		break;
         case 'D':
        PntDump2 = 1;
        write_en = 1;
        break;
//         case 'M':
//        MemDump = 0;
//        write_en = 1;
//        break;
         case 'P':
        PntDump = 1;
        write_en = 1;
        break;
         case 'W':
		write_en = 1;
		break;
	     case 'V':
		verify_en = 1;
		break;
	     case 'T':
		test_en = 1;
		break;
         case 'a':          //enable cart & unprotect
		write_en = 3;
		break;
	     default:
		usage(progname);
	  }
       }
       else {
	  if( file_name == NULL ) {
	     file_name = argv[i];
	  }
	  else {
	     usage(progname);
	  }
       }
    }
//   printf("program name=%s\n",progname);
//   printf("write_en=%x, verify=%x, test=%x\n",write_en,verify_en,test_en);
//   printf("filename=%s\n",file_name);

   wv_mode=0;
   if (verify_en){      // if sel=2 for write/verify
      sel=1;		// sel=1 for verify
   }
   else{
      sel=0;		// sel=0 for write
   }


   if (card_present==0){
      printf("\nNo V64jr card present!!!\07\n\n");
      return(-1);
   }
   else
      printf("V64jr card found at port%d\n",port_no);
   init_port();
   set_ai(3);
   set_data_read
   printf("control(rst,wdf,rcf) = %x\n",inportb(port_c));


   if (test_en){
      dram_size=test_dram();
      if (dram_size){
	 printf("\nDRAM size=%dMbits\n",(dram_size/2));
      }
      else {
	 printf("Error!!!\07\n");
      }
   }
   disp_on=1;		// display #/*
   if (file_name!=NULL){
      if (download_n64()!=0)
	 printf("download error !!!\n");
   }
   if (write_en)
      printf("dram write protect disable\n");
   if (write_en & 2)
      printf("run cart enable\n");

//   set_ai_data(5,write_en);		// d0=0 is write protect mode

//   if (MemDump)
//      MemoryDumpLoop();

//   if (MemDump2)
//      MemoryDumpLoop2();

   if (PntDump)
      PrintDump();

   if (PntDump2)
      PrintDumpLoop();

   end_port();

   return(0);
}

